Scriptname AddItemMenu2ContainerScript extends Quest  

import AddItemMenu2

string property		ROOT_MENU	= "ContainerMenu" autoReadonly
string Property 	MENU_ROOT	= "_root.Menu_mc." autoReadonly

Formlist[] Property lists Auto
ObjectReference Property chest Auto

int clipboardSearchKey

bool Function Ready(int resultIndex, bool itemSearch, string searchText)
	chest.Reset()
	if (AIM2_GetItems(resultIndex, lists, searchText))
		if (AddItemsToContainer(chest))
			chest.SetDisplayName(GetChestName(itemSearch, searchText))
			return true
		endif
	endif
	return false
endFunction

string Function GetChestName(bool bSearch, string str)
	string result
	if(bSearch && str)
		result = AIM2_GetLanguageString("SearchOfPrefix") + str
	else
		result = AIM2_GetListResultString()
	endif
	return result
endFunction

bool Function AddItemsToContainer(ObjectReference refr)
	bool result = false
	int index = 0
	if (!refr)
		return false
	endif
	while (index < lists.length)
		if (lists[index].GetSize() > 0)
			refr.AddItem(lists[index], AIM2_GetQuantity(index))
			if (!result)
				result = true
			endif
		endif
		index += 1
	endWhile
	return result
endFunction

Function Open(Actor akActor)
	RegisterForMenu("ContainerMenu")
	chest.Activate(akActor)
endFunction

Event OnMenuOpen(String MenuName)
	clipboardSearchKey = AIM2_GetClipboardKeyCode()
	if (clipboardSearchKey == 0)
		return
	endif
	RegisterForKey(clipboardSearchKey)
EndEvent

Event OnMenuClose(String MenuName)
	UnregisterForMenu("ContainerMenu")
	if (clipboardSearchKey == 0)
		return
	endif
	UnregisterForKey(clipboardSearchKey)
	clipboardSearchKey = 0
EndEvent

Event OnKeyDown(Int KeyCode)
	int entryID = UI.GetInt(ROOT_MENU, MENU_ROOT + "inventoryLists.itemList.selectedEntry.formId")
	if (entryID == 0)
		return
	endif
	form item = Game.GetFormEx(entryID)
	if (!item)
		return
	endif
	string name = item.GetName()
	if (name && AIM2_SetClipboardText(name))
		AIM2_DebugTrace(name)
		string str = AIM2_GetLanguageString("CopyName") + str
		Debug.Notification(str + name)
	endif
endEvent
